/***
 * 
 * These were commands used under windows to compile the whole project, this might come handy if you plan to edit it :
 set JAVA_HOME=C:\Program Files\Java\jdk1.8.0_121
 set BIN_DIR=F:\code\Orchestrator\bin
 set CLASSPATH=F:\code\Orchestrator\src
 set PROJECT_DIR=F:\code\Orchestrator
 "C:\Program Files\Java\jdk1.8.0_121\bin\javah.exe" -d %CLASSPATH% -classpath %CLASSPATH% Orchestrator.JNI
 C:\MinGW\bin\g++.exe -Wl,--add-stdcall-alias -I"%JAVA_HOME%\include" -I"%JAVA_HOME%\include\win32" -shared -fpermissive -static-libgcc -static-libstdc++ -o %BIN_DIR%\Orchestrator64.dll  %PROJECT_DIR%\src\Orchestrator_JNI.cpp %PROJECT_DIR%\src\SendKeys.cpp

 * Also, there are a LOT of warnings due to the fact i'm casting JVM types to window types, as the compiler dont understand this, he'll cry a lot, however, it works fine thought you may have problems if you run it under 32 bits jvm on 64 bits system
 * 32 bits compilation wont work unless you rework cpp code for it :
 * C:\MinGW\bin\g++.exe -Wl,--add-stdcall-alias -I"%JAVA_HOME%\include" -I"%JAVA_HOME%\include\win32" -shared -fpermissive -static-libgcc -static-libstdc++ -o %BIN_DIR%\Orchestrator64.dll  %PROJECT_DIR%\src\Orchestrator_JNI.cpp %PROJECT_DIR%\src\SendKeys.cpp
 */

package Orchestrator;

import java.awt.AWTException;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.net.URI;
import java.net.URISyntaxException;
import java.net.URL;
import java.security.CodeSource;
import java.security.ProtectionDomain;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Random;
import java.util.logging.Level;
import java.util.logging.Logger;

import javax.xml.parsers.ParserConfigurationException;

import org.jnativehook.GlobalScreen;
import org.jnativehook.NativeHookException;
import org.xml.sax.SAXException;

public class Main {

	static File orchestrator_exe_path = null ;
	static File orchestrator_ini_path = null ;
	static String server_ip = null;
	
	@SuppressWarnings({ "rawtypes", "unchecked" })
	static HashSet<Server> HashsetServers = new HashSet();
	@SuppressWarnings({ "unchecked", "rawtypes" })
	static HashSet<Account> HashsetAccounts = new HashSet();

	static JNI jni;
	
	/**
	 * These are datas that can be learned from Orchestrator.ini file
	 */
	static File gamedir = null ;
	static File user_mydoc_dir = null ;
	static String server = null;
	static String lang = null;
	static String main_character = null;
	static String gls_login_account= null;
	static String gls_login_queue= null;
	static String gls_login_queue_number= null;
	static String gls_dom= null;
	static String keybind_sync= null;
	static String keybind_launcher= null;
	static String keybind_write_instr = null;
	static String keybind_music = null;
	static String keybind_follow = null;
	static String keybind_raid_invit = null;
	static String keybind_kill_orchestrator=null;
	static String sendkeys_timer = null;
	static int main_character_hwnd = -1;
	static String raid_invit_timer = null;
	
	/**
	 * main, where everything starts ...
	 * @throws IOException 
	 */
	
	public static void main(String[] args) throws IOException
	{
		
		//initialize attributes		
		ini();
				
	    //check that needed files exists
		Main.log("Checking that needed files exists");
	    check_files();
		
		//fill data from ini file
	    Main.log("Reading Orchestrator.ini, filling in data");
		parse_inifile();
			
		//check if data entered by user are not wrong
		Main.log("Checking if user data is not wrong");
		check_user_data();		
		
		//show all initialized data 
		Main.log("Now Printing all initialized data");
		show_ini_data();
		
		//loads up DLL for JNI features
		Main.log("Loading up Orchestrator DLL");
		jni = new JNI();		
		
		Main.log("Setting up Keyboard Hook");
		try {
			Logger logger = Logger.getLogger(GlobalScreen.class.getPackage().getName());
			logger.setLevel(Level.OFF);
			GlobalScreen.registerNativeHook();

		} catch (NativeHookException e1) {
			    
			Main.log("NativeHookException main():97");
		}
		GlobalScreen.addNativeKeyListener(new KeyboardListener());
	
		boolean guard = true;
		int i=0;
		Main.log("Starting wait loop");
		while(guard)
		{
			if(i>65535)
			{
			guard=false;
			Main.log("Orchestrator is playing/waiting since 18h, now going to sleep ...");
			// This means Orchestrator will roughtly runs 18 hours before auto exit
			// who have a 18h long .abc playlist by the way ?
			}
			try {
				Thread.sleep(1000);
			} catch (InterruptedException e) {
				    
				Main.log("InterruptedException main():line 117");
			}
		i++;
		}	
		
		Main.log("Removing Keyboard Hook");
		try {
			GlobalScreen.unregisterNativeHook();
		} catch (NativeHookException e) {
			    
			Main.log("NativeHookException main():line 127");
		}
		Main.log("-------------LOG END HERE---------------");
    	Main.log(KeyboardListener.randomLOTRquote());
    	Main.log("----------------------------------------");
    	
    	System.exit(0);
	}
	
	
	/**
	 * This Method initialize logs, prints in it copyrights for some parts Orchestrator runs with
	 * and prepare .ini file parsing
	 * @throws URISyntaxException
	 * @throws SecurityException
	 * @throws IOException
	 */
	
	private static void ini() throws IOException
	{
		try {
			ProtectionDomain pp = Main.class.getProtectionDomain();
			CodeSource cs = pp.getCodeSource();
			URL rr = cs.getLocation();
			URI ww = rr.toURI();
			String str = new String(ww.getPath());
			File tt = new File(str);			
			String path =  tt.getPath();
			orchestrator_exe_path = new File (path.replace("\\Orchestrator.jar", ""));
			
		} catch (URISyntaxException e) {
			    
			Main.log("URISyntaxException ini():line 149");
		}
		
		//this create or empty the log file when starting, as we dont want to store a lot of logs
		File logfile = new File(orchestrator_exe_path.getPath()+"\\orchestrator.log");
		
		  boolean existsFlag = logfile.exists();

		    if(!existsFlag)
		    {
		        try {
		        	logfile.createNewFile();
		        } catch (IOException e) {
		            Main.log("could not create new log file :"+logfile.getPath());
		            e.printStackTrace();
		        }
		    }		
		 FileWriter fwOb = new FileWriter(orchestrator_exe_path.getPath()+"\\orchestrator.log", false); 
	     PrintWriter pwOb = new PrintWriter(fwOb, false);
	     pwOb.flush();
	     pwOb.close();
	     fwOb.close();	    
	    
	    Main.log("--------------------------LOG START HERE--------------------------------|");
	    Main.log("|System properties :\t\t\t\t\t\t\t\t\t\t\t\t\t|");
	    Main.log("|JVM is "+System.getProperty("sun.arch.data.model") +"bits version "+System.getProperty("java.version")+"\t\t\t\t\t\t\t\t\t\t|");
	    Main.log("|OS Architecture : " + System.getProperty("os.arch")+"\t\t\t\t\t\t\t\t\t\t\t\t|");
	    Main.log("|OS Name : " + System.getProperty("os.name")+"\t\t\t\t\t\t\t\t\t\t\t\t\t|");
	    Main.log("|OS Version : " + System.getProperty("os.version")+"\t\t\t\t\t\t\t\t\t\t\t\t\t\t|");
	    Main.log("------------------------------------------------------------------------|");
	    orchestrator_ini_path= new File(orchestrator_exe_path.getPath()+ "\\Orchestrator.ini");
	    Main.log("\n\t\t-- LICENSING --\t\t");
	    Main.log(" \n"
	     +"JNativeHook library is used in this program\n"
	     +"It is licensed under GNU General Public License v3.0 :\n"
	     +"For more informations check on :\n"
	     +"https://github.com/kwhat/jnativehook\n"
	     +" \n"
	     +"Sendkeys library is used is this program : \n"
	     +"Original Sources at :\n"
	     +"https://www.codeproject.com/Articles/6819/SendKeys-in-C\n"
	     +"----------------------------------------------------------------------------- \n"
	     +"Copyright (c) 2004 lallous <lallousx86@yahoo.com>\n"
	     +"All rights reserved.\n"	     
	     +"Redistribution and use in source and binary forms, with or without\n"
	     +"modification, are permitted provided that the following conditions\n"
	     +"are met:\n"
	     +"1. Redistributions of source code must retain the above copyright\n"
	     +"   notice, this list of conditions and the following disclaimer.\n"
	     +"2. Redistributions in binary form must reproduce the above copyright\n"
	     +"   notice, this list of conditions and the following disclaimer in the\n"
	     +"   documentation and/or other materials provided with the distribution.\n"
	     +" \n"
	     +"THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND\n"
	     +"ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE\n"
	     +"IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE\n"
	     +"ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE\n"
	     +"FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL\n"
	     +"DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS\n"
	     +"OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)\n"
	     +"HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT\n"
	     +"LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY\n"
	     +"OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF\n"
	     +"SUCH DAMAGE.\n"
	     +"----------------------------------------------------------------------------- \n"

	     +"The Original SendKeys copyright info\n"
	     +"----------------------------------------------------------------------------- \n"
	     +"SendKeys (sndkeys32.pas) routine for 32-bit Delphi.\n"
	     +"Written by Ken Henderson\n"
	     +"Copyright (c) 1995 Ken Henderson <khen@compuserve.com>\n"
	     +"----------------------------------------------------------------------------- \n"
	     +"----------------------------------------------------------------------------- \n"
+"_______________________________________________________________________________________________________________________|\n"
+"_____________________________________________	|																   |\n"	
+"___________________________________________	|	Description :												   |\n"
+"________________________________________	|	Orchestrator is an open source application giving the          |\n"
+"_______________________________________	|	possibility for one player in Lord of the Ring Online         |\n"
+"_______________________________________	|	MMORPG to set up and play his/her own orchestra.               |\n"
+"______________________________________	|	                                                               |\n"
+"___________________________________		|	Licensing : None, you can do whatever you want with this code  |\n" 
+"_________________________________		|	except for previously listed APIs Orchestrator is using        |\n"
+"____________________________________		|	(Sendkey and JNAtive Hook) which are copyrighted,              |\n"
+"__________________________________		|	please refer to their respective documentation to know more.   |\n"
+"__________________________________________	|   		                                                       |\n"
+"________________________________________	|	Source :												       |\n"
+"___________________________________________	|                                                                  |\n"
+"________________________________________ 		|																   |\n"
+"________________________________________		|   Credits : no credits, i'm too poor  		                               |\n"
+"______________________________________		|                                                                  |\n"
+"________________________________________________|__________________________________________________________________|\n");
	    
	}

	/**
	 * This Method check if .dll files and .ini files exists in Orchestrator directory
	 */
	private static void check_files()
	{
		if(!orchestrator_ini_path.exists())
		{
			Main.log("Orchestrator.ini file is missing in "+ Main.blur());
			System.exit(0);
		}
		
		if((! new File (orchestrator_exe_path.getPath()+"\\Orchestrator32.dll").exists()) && System.getProperty("sun.arch.data.model").equals("32"))
		{
			Main.log("Orchestrator32.dll file is missing in "+ Main.blur());
		}
		
		if((! new File (orchestrator_exe_path.getPath()+"\\Orchestrator64.dll").exists()) && System.getProperty("sun.arch.data.model").equals("64"))
		{
			Main.log("Orchestrator64.dll file is missing in "+ Main.blur());
		}
	}

	/**
	 * This method prints data gathered from ini file
	 */
	public static void show_ini_data() 
	{
		Main.log("#################################################################");
		Main.log("####################  INI FILE DATA #############################");
		Main.log("#################################################################");
		Main.log("main_character:"+main_character);
		Main.log("server:"+server);
		Main.log("gamedir:"+Main.blur());
		Main.log("user_mydoc_dir:"+Main.blur());
		Main.log("keybind_launcher:"+keybind_launcher);
		Main.log("keybind_sync:"+keybind_sync);
		Main.log("keybind_kill_orchestrator:"+keybind_kill_orchestrator);
		Main.log("keybind_follow:"+keybind_follow);
		Main.log("keybind_write_instr:"+keybind_write_instr);
		Main.log("keybind_music:"+keybind_music);
		Main.log("keybind_raid_invit:"+keybind_raid_invit);
		Main.log("sendkeys_timer:"+sendkeys_timer);
		Main.log("raid_invit_timer:"+ raid_invit_timer);
		Main.log("lang:"+lang);
		show_account_data();		
		Main.log("GLS DATA :");
		Main.log("gls_dom:"+gls_dom);
		Main.log("gls_login_account:"+gls_login_account);
		Main.log("gls_login_account:"+gls_login_queue);
		Main.log("gls_login_queue_number:"+gls_login_queue_number);	
		Main.log("#################################################################");
		Main.log("#################### END INI FILE DATA ##########################");
		Main.log("#################################################################");

	}
	
	
	/**
	 * This method prints account related data which were gathered in .ini file
	 */
	private static void show_account_data()
	{
		@SuppressWarnings("unchecked")
		HashSet<Account> HashsetAccounts2 =  (HashSet<Account>) HashsetAccounts.clone();

		Iterator<Account> local_ITaccounts = HashsetAccounts2.iterator();
		
		Main.log("|character|login|password|character_dir|hwnd|instrument_id");
		while(local_ITaccounts.hasNext())
		{
			Account a = local_ITaccounts.next();
			Main.log("|" + a.getCharacter() + "|" + Main.blur() + "|" + Main.blur() + "|" + Main.blur() + "|" + a.getHWND() + "|" + a.getInstrument_id() + "|");
		}
			
	}

	/**
	 *	This method will check is user didn't entered wrong data in .ini file 
	 */
	private static void check_user_data() 
	{
		//check gamedir and game exe
		if(! gamedir.exists())
		{
			Main.log("gamedir doesn't seems to exists :["+ Main.blur()+"]");
			System.exit(0);
		}
		
		if(! new File (gamedir.getPath()+"\\lotroclient.exe").exists())
		{
			Main.log("lotroclient.exe is missing in "+ Main.blur());
			System.exit(0);
		}
		
		//check if user_mydoc_dir exists
		if(! user_mydoc_dir.exists())
		{
			Main.log("user_mydoc_dir doesn't seems to exists :["+ Main.blur() +"]");
			System.exit(0);
		}
		
		//check if characters already exists in files
		Iterator<Account> local_ITaccounts = HashsetAccounts.iterator();
		while (local_ITaccounts.hasNext())
		{
		Account a = local_ITaccounts.next();
		String accountdir = user_mydoc_dir+"\\The Lord of the Rings Online\\PluginData\\"+a.getLogin();
		
		File f = new File (accountdir);
		
		if(! f.exists())
		{
			Main.log("["+Main.blur()+"] accountdir doesn't seems to exists");
			System.exit(0);
		}
		
		String[] FL = f.list();
		String serverdir = null;
		for (int i=0 ; i<FL.length ; i++ )
			{
				if(FL[i].contains(server))
				{
					serverdir=accountdir+"\\"+FL[i];
					File s = new File (serverdir);
					if(! s.exists())
					{
						Main.log("["+Main.blur()+"] serverdir doesn't seems to exists");
						System.exit(0);
					}
					
					File u = new File(s.getPath()+"\\"+a.getCharacter());
					
					if(! u.exists())
					{
						Main.log("["+Main.blur()+"] userdir in serverdir doesn't seems to exists");
						System.exit(0);
					}
					a.setCharacter_dir(u.getPath());
				}
			}				
		}
		//check if server exists
		Iterator<Server> local_ITservers = HashsetServers.iterator();
		boolean guard = true;
		while (local_ITservers.hasNext())
		{
			Server s= local_ITservers.next();
			 if (s.getServer_name().equals(server))
			 {
				 server_ip = s.getIp();
				 guard = false;
				 break;
			 }
		}
		if (guard)
		{
			Main.log("server ["+server+"] is unknown");
			System.exit(0);
		}		
	}
	
	/**
	 * This Method will Parse .ini file and initialize attributes based on their values
	 * @throws IOException
	 */
	private static void parse_inifile()
	{
		    FileReader input = null;
			try {
				input = new FileReader(orchestrator_ini_path);
				Main.log("Orchestrator.ini file is using ["+input.getEncoding()+"] encoding");
			} catch (FileNotFoundException e) {
				    
				Main.log("FileNotFoundException for orchestrator_ini_path parse_inifile():372");
			}
		    
		    BufferedReader bufRead = new BufferedReader(input);
		    String myLine = null;
		    try {
				while ((myLine = bufRead.readLine()) != null)
				{
				  //just in case user add some blank/spaces  at the start/end of lines
					myLine = myLine.trim();
				  
				  if (!( myLine.isEmpty() || myLine.charAt(0) == '#'))
				  {
				    String[] data = myLine.split("=");
				   
				    if(data.length!=2)
				    {
				    	Main.log("parser encountered wrong sized data while parsing :["+ Main.blur() +"]");
						System.exit(0);
				    }
				    
				    switch (data[0].toLowerCase().trim())
				    {
				    	case "gamedir":
				    	gamedir=new File(data[1].trim());
				        break;
				        
				    	case "user_mydoc_dir":
				        user_mydoc_dir=new File(data[1].trim());
				        break;
				        
				    	case "server":
				    	server=data[1].trim();
				    	break;
				        
				    	case "main_character":
				    	main_character=data[1].trim();
				    	break;
				    	
				    	case "account":
				    	String [] account = data[1].split(":");		        	
				    	  if(account.length!=3)
					        {
					        	Main.log("parser encountered wrong sized data while parsing an account :["+ Main.blur() +"]");
								System.exit(0);
					        }
				    	HashsetAccounts.add(new Account (account[0],account[1],account[2]));
				    	break;
				    	
				    	case "gls_login_account":
				    	gls_login_account=data[1].trim();
				    	break;
				    	
				    	case "gls_login_queue":
				    	gls_login_queue=data[1].trim();
				    	break;
				    	
				    	case "gls_dom":
				    	gls_dom=data[1].trim();
				    	break;
				    	
				    	case "gls_login_queue_number":
				    	gls_login_queue_number=data[1].trim();
				    	break;
				    	
				    	case "keybind_sync":
				    	keybind_sync=data[1].trim(); 	
				    	break;
				    	
				    	case "keybind_launcher":
				    	keybind_launcher=data[1].trim(); 
				    	break;	
				    	
				    	case "keybind_kill_orchestrator":
				    	keybind_kill_orchestrator=data[1].trim(); 
				    	break;
				    	
				    	case "keybind_write_instr":
				    	keybind_write_instr=data[1].trim(); 
				        break;
				        
				    	case "keybind_music":
				    	keybind_music=data[1].trim(); 
					    break;
					    
				    	case "keybind_follow":
				    	keybind_follow=data[1].trim(); 
						break;
						
				    	case "keybind_raid_invit":
				    	keybind_raid_invit=data[1].trim(); 
						break;
				    	
				    	case "sendkeys_timer":
				    	sendkeys_timer=data[1].trim();
				    	break;
						
				    	case "raid_invit_timer":
				    	raid_invit_timer=data[1].trim();
				    	break;
				    	
				    	case "lang":
				        lang=data[1].trim(); 
				       	break;	
				    	
				    	case "gls_serv":
				    	String [] server = data[1].split(":");	
				        	if(server.length!=2)
					        {
					        	Main.log("parser encountered null data while parsing gls_serv:["+ myLine +"]");
								System.exit(0);
					        }		        	
				        HashsetServers.add(new Server (server[0],server[1]));
				    	break;
				    }		        
				  }
				}
			} catch (IOException e) {
				    
				Main.log("IOException parse_inifile():line 484");
			}
		    try {
				bufRead.close();
			} catch (IOException e) {
				    
				Main.log("IOException parse_inifile():line 490");
			}
		  }

	/**
	 * This method is a call to Sync.main(), a bit useless
	 * @throws IOException
	 * @throws AWTException
	 * @throws InterruptedException
	 */
	public static void sync() 
	{		
			Sync.main();			
	}

	/**
	 * This method is a call to Launcher.main(), a bit useless
	 * @throws IOException
	 * @throws AWTException
	 * @throws InterruptedException
	 */
	public static void launch() 
	{
		try {
			Launcher.main();
		} catch (IOException | ParserConfigurationException | SAXException | AWTException | InterruptedException e) {
			    
			Main.log("IOException | ParserConfigurationException | SAXException | AWTException | InterruptedException launch():line 517");
		}
	}

	/**
	 * This method refill hwnd for account related data in case orchestrator 
	 * is starting with each window or lotro client already re titled by their character name
	 */
	public static void refillhwnd() 
	{
		
		Iterator<Account> local_ITaccounts = HashsetAccounts.iterator();
		int prev_hwnd = -1;
		Main.log("|character|login|password|character_dir|HWND      size:"+HashsetAccounts.size());
		while(local_ITaccounts.hasNext())
		{
			Account a = local_ITaccounts.next();
			int current_hwnd = Main.jni.gethwnd(a.getCharacter());//what if -1 ?
			
			//if the accound hwnd have not been initialized
			if(a.getHWND()==-1)
			{			
				if(prev_hwnd==current_hwnd)
				{
					a.setHWND(-1);
				}
				else 
				{
					a.setHWND(current_hwnd);
				}
				Main.log("|"+a.getCharacter()+"|"+Main.blur()+"|"+ Main.blur()+"|"+ Main.blur()+"|"+a.getHWND());
				if(a.getCharacter().equals(Main.main_character))
				{
					Main.main_character_hwnd = a.getHWND();
				}			
				prev_hwnd=current_hwnd;			
			}else {
			//if the accound hwnd have been initialized, we still need to check it's not a dead window 
				if(!Main.jni.iswindow( a.getHWND()))
				{
					a.setHWND(-1); // if so just tag is as not initialized
				}
			}
		}	
	}
	
	public static void log(String inString)
	{		
		File logfile = new File(orchestrator_exe_path.getPath()+"\\orchestrator.log");
		
		  boolean existsFlag = logfile.exists();

		    if(!existsFlag)
		    {
		        try {
		        	System.out.println("creates logfile :"+logfile.getPath());
		        	logfile.createNewFile();
		        } catch (IOException e) {
		        	System.out.println("could not create new log file :"+logfile.getPath());
		            e.printStackTrace();
		        }
		    }
		FileWriter fstream = null;
		try {
			fstream = new FileWriter(logfile, true);
		} catch (IOException e1) {			
			e1.printStackTrace();
		}
	    BufferedWriter out = new BufferedWriter(fstream);
		
	    try {
	         out.write(inString+'\n');
	        
	         out.flush();
	         out.close();
	    } catch (IOException e) {
	        System.out.println("could not write to the file");
	        e.printStackTrace();
	    }	    
	}
	
	/**
	 * Point of this method is to return a random sized string of '*' characters
	 * so that user can safely share logs without password/login/tickets and others sensitive datas
	 * @return
	 */
	public static String blur()
	{
		int s1 = new Random().nextInt(5);
		int s2 = new Random().nextInt(5);
		int s3 = new Random().nextInt(5);
		int s4 = new Random().nextInt(5);
		int sum = s1 + s2 + s3 + s4 ;
		
		String blurred = "*";
		
		for (int i = 1 ; i < sum ; i++ )
		{
			blurred=blurred+"*";
		}
		
		return blurred;		
	}
	
}
